Loading...
Searching...
No Matches
Sip_error

## Macros

#define | sip_error(sip)
| Access a SIP erroneous headers structure sip_error_t from sip_t.
#define | SIP_ERROR_INIT()
| Initializer for structure sip_error_t.
#define | SIPTAG_ERROR(x)
| Tag list item for pointer to a erroneous headers structure sip_error_t.
#define | SIPTAG_ERROR_REF(x)
| Tag list item for reference to a erroneous headers pointer.
#define | SIPTAG_ERROR_STR(s)
| Tag list item for string with erroneous headers value.
#define | SIPTAG_ERROR_STR_REF(x)
| Tag list item for reference to a erroneous headers string.

## Typedefs

typedef msg_error_t | sip_error_t
| @

## Functions

issize_t | sip_error_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP erroneous headers.
issize_t | sip_error_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP erroneous headers.
sip_error_t * | sip_error_init (sip_error_t x[1])
| Initialize a structure sip_error_t.
int | sip_is_error (sip_header_t const *header)
| Test if header object is instance of sip_error_t.
sip_error_t * | sip_error_dup (su_home_t *home, sip_error_t const *hdr))
| Duplicate a list of erroneous headers header structures sip_error_t.
sip_error_t * | sip_error_copy (su_home_t *home, sip_error_t const *hdr))
| Copy a list of erroneous headers header structures sip_error_t.
sip_error_t * | sip_error_make (su_home_t *home, char const *s))
| Make a erroneous headers structure sip_error_t.
sip_error_t * | sip_error_format (su_home_t *home, char const *fmt,...)))
| Make a erroneous headers from formatting result.

## Variables

msg_hclass_t | sip_error_class []
| Header class for erroneous headers.
tag_typedef_t | siptag_error
| Tag for erroneous headers object.
tag_typedef_t | siptag_error_str
| Tag for string with erroneous headers value.

## Detailed Description

## Macro Definition Documentation

## SIP_ERROR_INIT

#define SIP_ERROR_INIT | ( |  | ) |

Initializer for structure sip_error_t.

A static sip_error_t structure for erroneous headers must be initialized with the SIP_ERROR_INIT() macro. For instance,

sip_error_t sip_error = SIP_ERROR_INIT;
sip_error
#define sip_error(sip)
Access a SIP erroneous headers structure sip_error_t from sip_t.
Definition sip_protos.h:16315
sip_error_t
msg_error_t sip_error_t
@
Definition sip.h:134
SIP_ERROR_INIT
#define SIP_ERROR_INIT()
Initializer for structure sip_error_t.
Definition sip_protos.h:16332

## SIPTAG_ERROR

#define SIPTAG_ERROR | ( |  | x | ) |

Tag list item for pointer to a erroneous headers structure sip_error_t.

The SIPTAG_ERROR() macro is used to include a tag item with a pointer to a sip_error_t structure in a tag list.

Parameters

  x | pointer to a sip_error_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_ERROR_REF().

## SIPTAG_ERROR_STR

#define SIPTAG_ERROR_STR | ( |  | s | ) |

Tag list item for string with erroneous headers value.

The SIPTAG_ERROR_STR() macro is used to include a tag item with a string containing value of a sip_error_t header in a tag list.

Parameters

  s | pointer to a string containing erroneous headers value, or NULL.

The string in SIPTAG_ERROR_STR() can be converted to a sip_error_t header structure by giving the string s has second argument to function sip_error_make().

The corresponding tag taking reference parameter is SIPTAG_ERROR_STR_REF().

## Typedef Documentation

## sip_error_t

typedef msg_error_t sip_error_t

@

The erroneous headers are stored in sip_error_t structure.

Note
  Other headers (like duplicate Content-Length headers) may be put into the list of erroneous headers (`sip->sip_error`). If the list of erroneous headers is processed, the header type must be validated first by calling sip_is_error() (or by other relevant tests).

The structure sip_error_t contains representation of error headers.

The sip_error_t is defined as follows:

typedef struct msg_error_s {
msg_common_t er_common[1]; // Common fragment info
msg_error_t *er_next; // Link to next header
char const *er_name; // Name of bad header (if any)
} sip_error_t;
msg_error_t
struct msg_error_s msg_error_t
msg_common_t
struct msg_common_s msg_common_t
msg_error_s
msg_error_s::er_name
char const * er_name
msg_error_s::er_common
msg_common_t er_common[1]
msg_error_s::er_next
msg_error_t * er_next

## Function Documentation

## sip_error_copy()

sip_error_t * sip_error_copy | ( | su_home_t * | home,
|  | sip_error_t const * | hdr )

inline

Copy a list of erroneous headers header structures sip_error_t.

The function sip_error_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  error = sip_error_copy(home, sip->sip_error);
  sip_error_copy
  sip_error_t * sip_error_copy(su_home_t *home, sip_error_t const *hdr))
  Copy a list of erroneous headers header structures sip_error_t.
  Definition sip_protos.h:16462

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_error_dup()

sip_error_t * sip_error_dup | ( | su_home_t * | home,
|  | sip_error_t const * | hdr )

inline

Duplicate a list of erroneous headers header structures sip_error_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  error = sip_error_dup(home, sip->sip_error);
  sip_error_dup
  sip_error_t * sip_error_dup(su_home_t *home, sip_error_t const *hdr))
  Duplicate a list of erroneous headers header structures sip_error_t.
  Definition sip_protos.h:16419

Returns
  A pointer to the newly duplicated sip_error_t header structure, or NULL upon an error.

## sip_error_format()

sip_error_t * sip_error_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a erroneous headers from formatting result.

Make a new sip_error_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_error_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_error_init()

sip_error_t * sip_error_init | ( | sip_error_t | x[1] | ) |

inline

Initialize a structure sip_error_t.

An sip_error_t structure for erroneous headers can be initialized with the sip_error_init() function/macro. For instance,

sip_error_t sip_error;
sip_error_init(&sip_error);
sip_error_init
sip_error_t * sip_error_init(sip_error_t x[1])
Initialize a structure sip_error_t.
Definition sip_protos.h:16350

## sip_error_make()

sip_error_t * sip_error_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a erroneous headers structure sip_error_t.

The function sip_error_make() makes a new sip_error_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_error_t header structure, or NULL upon an error.

## sip_is_error()

int sip_is_error | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_error_t.

Check if the header class is an instance of erroneous headers object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header error
  0 | (false) otherwise

## Variable Documentation

## sip_error_class

msg_hclass_t sip_error_class[]

extern

Header class for erroneous headers.

The header class sip_error_class defines how a SIP erroneous headers is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_error_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.